using System;
using System.ComponentModel;
using System.Collections.Generic;
using System.Diagnostics;
using System.Text;
using System.Net.Sockets;
using System.Net;
using System.Windows.Forms;
using System.Threading;

namespace QQClass
{
    public partial class UDPSocket : Component
    {
        private IPEndPoint ServerEndPoint = null;   //˵
        private UdpClient UDP_Server = new UdpClient(); //,ҲUDPSocket
        private System.Threading.Thread thdUdp; //һ߳
        public delegate void DataArrivalEventHandler(byte[] Data, IPAddress Ip, int Port);  //һйܷ
        public event DataArrivalEventHandler DataArrival;   //ͨйڿؼжһ¼
        private string localHost = "127.0.0.1";
        [Browsable(true), Category("Local"), Description("IPַ")]   //ڡԡʾlocalHost
        public string LocalHost
        {
            get { return localHost; }
            set { localHost = value; }
        }

        private int localPort = 11000;
        [Browsable(true), Category("Local"), Description("ض˿ں")] //ڡԡʾlocalPort
        public int LocalPort
        {
            get { return localPort; }
            set { localPort = value; }
        }

        private bool active = false;
        [Browsable(true), Category("Local"), Description("")]   //ڡԡʾactive
        public bool Active
        {
            get { return active; }  
            set //Զȡֵ
            { 
                active = value;
                if (active) //ֵΪTrueʱ
                {
                    OpenSocket();   //򿪼
                }
                else
                {
                    CloseSocket();  //رռ
                }
            }
        }


        public UDPSocket()
        {
            InitializeComponent();
        }

        public UDPSocket(IContainer container)
        {
            container.Add(this);

            InitializeComponent();
        }

        protected void Listener()   //
        {
            ServerEndPoint = new IPEndPoint(IPAddress.Any,localPort);   //IPַͶ˿ں˵洢
            if (UDP_Server != null)
                UDP_Server.Close();
            UDP_Server = new UdpClient(localPort);  //һµĶ˿ں
            UDP_Server.Client.ReceiveBufferSize = 1000000000;   //ջС
            UDP_Server.Client.SendBufferSize = 1000000000;  //ͻС
            
            try
            {
                thdUdp = new Thread(new ThreadStart(GetUDPData));   //һ߳
                thdUdp.Start(); //ִеǰ߳
            }
            catch (Exception e)
            {
                MessageBox.Show(e.ToString());  //ʾ̵߳ĴϢ
            }
        }

        private void GetUDPData()   //ȡǰյϢ
        {
            while (active)
            {
                try
                {
                    byte[] Data = UDP_Server.Receive(ref ServerEndPoint);   //ȡԶϢתɶ
                    if (DataArrival != null)    //ǰй
                    {
                        DataArrival(Data, ServerEndPoint.Address, ServerEndPoint.Port);//õǰؼDataArrival¼ϢԶ̼
                    }
                    Thread.Sleep(0);
                }
                catch { }
            }
        }

        private void CallBackMethod(IAsyncResult ar)
        {
            //첽״̬ar.AsyncStateУȡίж
            DataArrivalEventHandler dn = (DataArrivalEventHandler)ar.AsyncState;
            //һҪEndInvoke³ܲ
            dn.EndInvoke(ar);
        }


        public void Send(System.Net.IPAddress Host, int Port, byte[] Data)
        {
            try
            {
                IPEndPoint server = new IPEndPoint(Host, Port);    //IPַͶ˿ںʵһIPEndPoint
                UDP_Server.Send(Data, Data.Length, server);         //ϢԶ̼
            }
            catch (Exception e)
            {
                MessageBox.Show(e.ToString());
            }
        } 

        private void OpenSocket()    //socket
        {
            Listener();         //ͨ÷UDPЭм
        }

        private void CloseSocket()    //رsocket
        {
            if (UDP_Server != null)     //socketΪ
                UDP_Server.Close();     //رsocket
            if (thdUdp != null)         //Զ̱߳
            {
                Thread.Sleep(30);       //˯߳
                thdUdp.Abort();         //ر߳
            }
        }
    }
}
